{
 ----------------------------------------------------------------------------
 PROGRAMA REALIZADO POR:  IIGO HERVIAS, "HAYAWATA".   (hayawata@teleline.es)
 ----------------------------------------------------------------------------
}



Program TreeDeLosCuyons;

Uses crt,dos,ihg;

{    SearchRec = record
       Fill: array[1..21] of Byte;
       Attr: Byte;
       Time: Longint;
       Size: Longint;
       Name: string [12];
     end; }

Type

  ptro = ^nodo;

  nodo = record
           Attr : Byte;
           nombre : String;
           abajo, dcha : ptro;
           HabriaMas : boolean;
         end;



Var { variables globales }

     Contador : Byte;
     Ordenado, Color, Pausa : Boolean;
     NumRamas, RamaActual : Integer;


Procedure Ayuda;
  begin
    writeln;
    writeln ('  TREE  [/p]  [/nc]  [/o]  [/<numero>]');
    writeln;
    writeln ('   /p         =  Pausa');
    writeln ('   /nc        =  No Color');
    writeln ('   /o         =  Ordenado alfabticamente');
    writeln ('   /<numero>  =  Nmero de niveles que se desean visualizar');
  end;


Procedure Destruye ( p : ptro );
  begin
    if p <> nil then begin
      Destruye ( p^.dcha );
      Destruye ( p^.abajo );
      Dispose ( p );
      p := nil;
    end;
  end;


Procedure Ordena ( var CL : Ptro );
  Var NewCL, ActNL, AntCL, AntMenor, ActMenor, AntAux, ActAux : Ptro;
  begin

    if CL <> nil then begin

      NewCL := nil;
      ActNL := nil;
      While CL <> nil do begin
        AntMenor := nil;
        ActMenor := CL;
        AntAux := CL;
        ActAux := CL^.Abajo;
        While ActAux <> nil do begin

          if ActAux^.Nombre < ActMenor^.Nombre then begin
            ActMenor := ActAux;
            AntMenor := AntAux;
          end;
          AntAux := ActAux;
          ActAux := ActAux^.Abajo;

        end;

        If AntMenor <> nil then
          AntMenor^.Abajo := ActMenor^.Abajo
        else
          CL := ActMenor^.Abajo;

        If ActNL <> nil then
          ActNL^.Abajo := ActMenor
        else
          NewCL := ActMenor;
        ActNL := ActMenor;
        ActNL^.Abajo := nil;

      end;

      CL := NewCL;
      ActAux := CL;
      While ActAux <> nil do begin
        Ordena ( ActAux^.Dcha );
        ActAux := ActAux^.Abajo;
      end;

    end;

  end;

Function HayMas ( algo : string ) : Boolean;
  Var DirInfo : SearchRec;
      Directorio : Word;
      Devolver : Boolean;
  begin
    ChDir ( algo );
    Devolver := false;

    Directorio := AnyFile;
    FindFirst ( '*.*' , Directorio, DirInfo);
    while (DosError = 0) and (not devolver) do begin
      if ((DirInfo.Attr AND 16) = 16 ) AND ( DirInfo.name[1] <> '.' ) then
        Devolver := true;
      FindNext (DirInfo);
    end;

    HayMas := devolver;
    ChDir ( '..' );
  end;


Procedure Cargar_Estructura ( p : Ptro );
  Var Directorio : Word;
      DirInfo : SearchRec;
      DeAndeVengo : Ptro;
      Derecha : Boolean;
      aux : Ptro;
  begin
    DeAndeVengo := p;
    Derecha := true;
    Directorio := AnyFile;
    FindFirst ( '*.*' , Directorio, DirInfo);
    while DosError = 0 do begin
      if ((DirInfo.Attr AND 16) = 16 ) AND ( DirInfo.name[1] <> '.' ) then begin
        new ( aux );
        if Derecha then
          p^.dcha := aux
        else
          p^.abajo := aux;
        aux^.nombre := DirInfo.Name;
        aux^.Attr := DirInfo.Attr;
        aux^.HabriaMas := false;
        inc ( RamaActual );
        if RamaActual <= NumRamas then begin
          ChDir ( DirInfo.Name );
          Cargar_Estructura ( aux );
          ChDir ( '..' );
        end else begin
          aux^.HabriaMas := HayMas ( DirInfo.Name );
          aux^.dcha := nil;
        end;
        dec ( RamaActual );
        Derecha := false; p := aux;
      end;
      FindNext (DirInfo);
    end;
    if Derecha then
      p^.dcha := nil
    else
      p^.abajo := nil;
  end;


Procedure Mostrar ( p : ptro; nivel : byte; antes : string );
  var i : byte;
  Begin
    while p<>nil do begin
      if color then textcolor ( White );
      write ( antes );

      if p^.abajo <> nil then begin
        write ( '-' );
        antes := antes + '  ';
      end else begin
        write ( '-' );
        antes := antes + '   ';
      end;

      antes := copy ( antes , 1 , nivel*3 );

      if ( ( p^.Attr AND 2 ) = 2 ) OR ( ( p^.Attr AND 4 ) = 4 ) then
        if color then textcolor ( Cyan ) else
      else
        if color then textcolor ( LightCyan );

      write ( p^.nombre );

      if p^.HabriaMas then
        writeln ( ' {+}')
      else
        writeln;

      inc ( contador );
      if ( contador = 23 ) AND pausa then begin
        if Readkey = #27 then pausa := false;
        Contador := 1;
      end;

      Mostrar ( p^.dcha , nivel+1 , antes );

      antes := copy ( antes , 1 , (nivel-1)*3 );
      p := p^.abajo;
    end;
  End;

Var p : ptro;
    NombreDir, Param, Numeros : String;
    i : byte;
    kk : integer;

begin

  Pausa := false;
  Color := true;
  NumRamas := MaxInt;
  Ordenado := false;

  for i := 1 to paramcount do begin
    Param := paramstr(i);
    if mayusculas(param) = '/P' then Pausa := true
    else if mayusculas(param) = '/NC' then Color := false
    else if mayusculas(param) = '/O' then Ordenado := true
    else if param = '/?' then begin
      ayuda;
      exit;
    end
    else if (param[1] = '/') and ( length(param) > 1 ) then begin
      Numeros := copy ( param , 2 , length(param)-1 );
      Val ( Numeros, NumRamas , kk );
    end;
  end;

  GetDir ( 0 , NombreDir );

  writeln;
  if color then textcolor ( LightCyan );
  writeln ( NombreDir );

  new ( p ); RamaActual := 1;
  Cargar_Estructura ( p );

  Contador := 1;
  if Ordenado then Ordena (p^.dcha);
  Mostrar ( p^.dcha , 1 { nivel 1 }, '' );

  Destruye ( p^.dcha );
  Dispose ( p );

  if color then begin
    textcolor ( LightGray );
    write ( '                                                                               ' , #13 );
  end;

end.
